<?php

namespace App\Domain\Contents\LandingWidgets\Props;

/**
 * Class ComplexProps
 * @package App\Domain\Contents\LandingWidgets\Props
 */
class ComplexProps extends BaseProps
{
    /**
     * @var array
     */
    protected $props = [];

    /**
     * ComplexProps constructor.
     * @param string $label
     * @param bool $required
     * @param string $type
     * @param string $default
     */
    public function __construct(string $label = '', bool $required = false, string $type = 'complex', string $default = '')
    {
        $this->label = $label;
        $this->required = $required;
        $this->type = $type;
        $this->default = $default;
    }

    /**
     * @return array
     */
    public function getProps(): array
    {
        return $this->props;
    }

    /**
     * @param $props
     * @return $this
     */
    public function setProps($props)
    {
        $this->props = $props;

        return $this;
    }

    /**
     * @param array $fields [field code => field value prefix]
     * @return $this
     */
    public function fieldsToAutogenerate($fields = [])
    {
        $this->extraFields['autogenerated_fields'] = $fields;

        return $this;
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        $prop = parent::toArray();
        $complexProps = $this->getProps();

        return $this->multiple
            ? array_merge($prop, ["multiple" => $this->multiple, "array_item" => $complexProps])
            : array_merge($prop, ["complex" => $complexProps]);
    }
}
